/* stages */
int stage;

/* background */
PImage default_background;

/* southpark */
Southpark default_character;

/* arrows, swords, lightnings */
Arrow arrow1;
Arrow arrow2;
Arrow arrow3;
Arrow arrow4;
Arrow arrow5;
Arrow arrow6;
Arrow arrow7;
Arrow arrow8;
Sword sword1;
Sword sword2;
Sword sword3;
Sword sword4;
Sword sword5;
Sword sword6;
Sword sword7;
Sword sword8;
SmallArrow smallArrow1;
SmallArrow smallArrow2;
SmallArrow smallArrow3;

/* score */
Score score;

void setup(){
 /* stages */
 stage = 1;
  
 /* background */
 size(1024,768); 
 
 /* images */
 default_background = loadImage ("img/default_background.png");
 
 /* Southpark */
 default_character = new Southpark();

 
 /* arrows, swords*/
 arrow1 = new Arrow(random(5,1435), random(-400,-200));
 arrow2 = new Arrow(random(5,1435), random(-600,-400));
 arrow3 = new Arrow(random(5,1435), random(-800,-600));
 arrow4 = new Arrow(random(5,1435), random(-1000,-800));
 arrow5 = new Arrow(random(5,1435), random(-400,-200));
 arrow6 = new Arrow(random(5,1435), random(-600,-400));
 arrow7 = new Arrow(random(5,1435), random(-800,-600));
 arrow8 = new Arrow(random(5,1435), random(-1000,-800));
 sword1 = new Sword(random(5,1435), random(-400,-200));
 sword2 = new Sword(random(5,1435), random(-600,-400));
 sword3 = new Sword(random(5,1435), random(-800,-600));
 sword4 = new Sword(random(5,1435), random(-500,-300));
 sword5 = new Sword(random(5,1435), random(-600,-400));
 sword6 = new Sword(random(5,1435), random(-450,-200));
 sword7 = new Sword(random(5,1435), random(-900,-700));
 sword8 = new Sword(random(5,1435), random(-950,-550));
 smallArrow1 = new SmallArrow(random(125,600),-200);
 smallArrow2 = new SmallArrow(random(750,1305),-200);
 smallArrow3 = new SmallArrow(random(550,800),-200);

 
 /* score */
 score = new Score();
 
 
}

void draw(){
  /* start */
  if (stage == 1){
  /* background */
  image(default_background,0,0);
  fill(0);
  textAlign(LEFT, TOP);
  textSize(40);
  text("Press 'p' to play",10,10);
  
  if (key == 'p'){ stage = 2;}
  /* Southpark */
    default_character.display();
   } //CLOSE STAGE 1
  
  /* playing */  
  if (stage == 2){
  /* background */
  image(default_background,0,0);  
  
  /* Southpark */ 
  default_character.display(); 
  default_character.move();
  
  /* arrows, swords */
    arrow1.display();
    arrow1.move();
    
    arrow2.display();
    arrow2.move();
    
    arrow3.display();
    arrow3.move();
    
    arrow4.display();
    arrow4.move();
    
    arrow5.display();
    arrow5.move();
    
   if (score.score > 50){
    arrow6.display();
    arrow6.move();
    
    arrow7.display();
    arrow7.move();
    
    sword1.display();
    sword1.move();
    
    sword2.display();
    sword2.move();
    
    sword3.display();
    sword3.move();
  
    sword4.display();
    sword4.move();
  
    sword5.display();
    sword5.move();
 }
 
 if (score.score > 80){
   arrow1.speed = random(7,8);
   arrow2.speed = random(7,8);
   arrow3.speed = random(7,8);
   arrow4.speed = random(7,8);
   arrow5.speed = random(7,8);
   arrow6.speed = random(7,8);
   arrow7.speed = random(7,8);
   arrow8.speed = random(7,8);
 }
 
 if (score.score > 100 && score.score < 180){
  smallArrow1.display();
  smallArrow1.move();
  
  smallArrow2.display();
  smallArrow2.move();
 }
 
 
 if (score.score > 200){
   sword1.speed = random(5.5,7);
   sword2.speed = random(5.5,7);
   sword3.speed = random(5.5,7);
   sword4.speed = random(5.5,7);
   sword5.speed = random(5.5,7);
   sword6.speed = random(5.5,7);
   sword7.speed = random(5.5,7);
   sword8.speed = random(5.5,7);
   
 }
 
 if (score.score > 200){
   smallArrow1.speed = random(10,11);
   smallArrow2.speed = random(10,11);
   smallArrow3.speed = random(10,11);
 }
 
 
 if (score.score > 220){
   
  arrow8.display();
  arrow8.move();
   
  sword6.display();
  sword6.move();
  
  sword7.display();
  sword7.move();

  sword8.display();
  sword8.move();
 }
 
 if (score.score > 220 && score.score < 300){
  smallArrow1.display();
  smallArrow1.move();
  
  smallArrow2.display();
  smallArrow2.move();
  
  smallArrow3.display();
  smallArrow3.move();
 }
 
 
 if ( score.score > 350){
  smallArrow1.display();
  smallArrow1.move();
  
  smallArrow2.display();
  smallArrow2.move();
  
  smallArrow3.display();
  smallArrow3.move();
 }
 
 if ( score.score > 400){
   smallArrow1.speed = random(12,13);
   smallArrow2.speed = random(12,13);
   smallArrow3.speed = random(12,13);
 }
 
   
 
  /* if Southpark hit */
      if( arrow1.Ypos + 100 >= default_character.Ypos && arrow1.Ypos + 10 <= default_character.Ypos + 135 && arrow1.Xpos + 8 >= default_character.Xpos && arrow1.Xpos + 8 <= default_character.Xpos + 100){
      stage = 3;}
      
      if( arrow2.Ypos + 100 >= default_character.Ypos && arrow2.Ypos + 10 <= default_character.Ypos + 135 && arrow2.Xpos + 8 >= default_character.Xpos && arrow2.Xpos + 8 <= default_character.Xpos + 100){
      stage = 3;}
      
      if( arrow3.Ypos + 100 >= default_character.Ypos && arrow3.Ypos + 10 <= default_character.Ypos + 135 && arrow3.Xpos + 8 >= default_character.Xpos && arrow3.Xpos + 8 <= default_character.Xpos + 100){
      stage = 3;}
      
      if( arrow4.Ypos + 100 >= default_character.Ypos && arrow4.Ypos + 10 <= default_character.Ypos + 135 && arrow4.Xpos + 8 >= default_character.Xpos && arrow4.Xpos + 8 <= default_character.Xpos + 100){
      stage = 3;}
      
      if( arrow5.Ypos + 100 >= default_character.Ypos && arrow5.Ypos + 10 <= default_character.Ypos + 135 && arrow5.Xpos + 8 >= default_character.Xpos && arrow5.Xpos + 8 <= default_character.Xpos + 100){
      stage = 3;}
      
      if( arrow6.Ypos + 100 >= default_character.Ypos && arrow6.Ypos + 10 <= default_character.Ypos + 135 && arrow6.Xpos + 8 >= default_character.Xpos && arrow6.Xpos + 8 <= default_character.Xpos + 100){
      stage = 3;}
      
      if( arrow7.Ypos + 100 >= default_character.Ypos && arrow7.Ypos + 10 <= default_character.Ypos + 135 && arrow7.Xpos + 8 >= default_character.Xpos && arrow7.Xpos + 8 <= default_character.Xpos + 100){
      stage = 3;}
      
      if( arrow8.Ypos + 100 >= default_character.Ypos && arrow8.Ypos + 10 <= default_character.Ypos + 135 && arrow8.Xpos + 8 >= default_character.Xpos && arrow8.Xpos + 8 <= default_character.Xpos + 100){
      stage = 3;}
      
      if( sword1.Ypos + 100 >= default_character.Ypos && sword1.Ypos + 10 <= default_character.Ypos + 135 && sword1.Xpos + 10 >= default_character.Xpos && sword1.Xpos + 10 <= default_character.Xpos + 100){
      stage = 3;}
      
      if( sword2.Ypos + 100 >= default_character.Ypos && sword2.Ypos + 10 <= default_character.Ypos + 135 && sword2.Xpos + 10 >= default_character.Xpos && sword2.Xpos + 10 <= default_character.Xpos + 100){
      stage = 3;}
      
      if( sword3.Ypos + 100 >= default_character.Ypos && sword3.Ypos + 10 <= default_character.Ypos + 135 && sword3.Xpos + 10 >= default_character.Xpos && sword3.Xpos + 10 <= default_character.Xpos + 100){
      stage = 3;}
      
      if( sword4.Ypos + 100 >= default_character.Ypos && sword4.Ypos + 10 <= default_character.Ypos + 135 && sword4.Xpos + 10 >= default_character.Xpos && sword4.Xpos + 10 <= default_character.Xpos + 100){
      stage = 3;}
      
      if( sword5.Ypos + 100 >= default_character.Ypos && sword5.Ypos + 10 <= default_character.Ypos + 135 && sword5.Xpos + 10 >= default_character.Xpos && sword5.Xpos + 10 <= default_character.Xpos + 100){
      stage = 3;}
      
      if( sword6.Ypos + 100 >= default_character.Ypos && sword6.Ypos + 10 <= default_character.Ypos + 135 && sword6.Xpos + 10 >= default_character.Xpos && sword6.Xpos + 10 <= default_character.Xpos + 100){
      stage = 3;}
      
      if( sword7.Ypos + 100 >= default_character.Ypos && sword7.Ypos + 10 <= default_character.Ypos + 135 && sword7.Xpos + 10 >= default_character.Xpos && sword7.Xpos + 10 <= default_character.Xpos + 100){
      stage = 3;}
      
      if( sword8.Ypos + 100 >= default_character.Ypos && sword8.Ypos + 10 <= default_character.Ypos + 135 && sword8.Xpos + 10 >= default_character.Xpos && sword8.Xpos + 10 <= default_character.Xpos + 100){
      stage = 3;}
      
      if( smallArrow1.Ypos + 45 >= default_character.Ypos && smallArrow1.Ypos + 5 <= default_character.Ypos + 135 && smallArrow1.Xpos + 120 >= default_character.Xpos + 15 && smallArrow1.Xpos <= default_character.Xpos + 95){
      stage = 3;}
      
      if( smallArrow2.Ypos + 45 >= default_character.Ypos && smallArrow2.Ypos + 5 <= default_character.Ypos + 135 && smallArrow2.Xpos + 120 >= default_character.Xpos + 15 && smallArrow2.Xpos <= default_character.Xpos + 95){
      stage = 3;}
      
       if( smallArrow3.Ypos + 45 >= default_character.Ypos && smallArrow3.Ypos + 5 <= default_character.Ypos + 135 && smallArrow3.Xpos + 120 >= default_character.Xpos + 15 && smallArrow3.Xpos <= default_character.Xpos + 95){
      stage = 3;}      
      
  /* score */
  score.display();
  score.betterScore();
  } // CLOSE STAGE 2
  
  /* end */
  if (stage == 3){
   /* background */
  image(default_background,0,0);
  fill(0);
  textAlign(LEFT, TOP);
  textSize(40);
  text("Press 's' for startscreen",10,10);
    
  /* score */
  fill(255,100);
  rect(205,395,695,80,7);
  
  fill(0);
  textSize(60);
  text("Your highscore: "+score.score, 220,400);
  
  /* reset */
  if (key == 's'){ setup();}
  } // CLOSE STAGE 3
  
}

/* move with arrow keys */
void keyPressed() {
  int k = keyCode;
  if (k == ENTER | k == RETURN)
    default_character.speed = default_character.speed + 1;
  else if (k == ' ') 
    default_character.speed = default_character.speed - 1;
  else if (k == LEFT)   default_character.left  = true;
  else if (k == RIGHT)  default_character.right = true;
}
void keyReleased() {
  int k = keyCode;
  if (k == LEFT)        default_character.left  = false;
  else if (k == RIGHT)  default_character.right = false;
}
 









